-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 04525 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--

update SCHEMA_VERSION set VERSION=4525;

create table RELEASES (
  RELEASE_ID number constraint NOT_NULL_RLS_ID not null,
  OPTIMISTIC_LOCK_VERSION number constraint NOT_NULL_RLS_OPT_LOCK_VER not null,
  PRODUCT varchar(255) constraint NOT_NULL_RLS_PRODUCT not null,
  VERSION varchar(255) constraint NOT_NULL_RLS_VERSION not null,
  constraint PK_RELEASES primary key (RELEASE_ID)
);

create unique index IDX_UNIQUE_RELEASE on RELEASES
  (PRODUCT, VERSION);

alter table PARCELS
  add RELEASE_ID number constraint NOT_NULL_PARCELS_RLS_ID not null;

alter table PARCELS
  add constraint FK_PARCEL_RELEASE
  foreign key (RELEASE_ID)
  references RELEASES (RELEASE_ID)
  deferrable initially immediate;

create index IDX_PARCEL_RELEASE on PARCELS (RELEASE_ID);

create table CLUSTER_MANAGED_RELEASES (
  CLUSTER_ID number constraint NOT_NULL_CLSTR_MNGD_RLS_CLSTR not null,
  RELEASE_ID number constraint NOT_NULL_CLSTR_MNGD_RLS_RLS not null,
  primary key (CLUSTER_ID, RELEASE_ID)
);

alter table CLUSTER_MANAGED_RELEASES
  add constraint FK_CLSTR_MNGD_RLS_CLSTR
  foreign key (CLUSTER_ID)
  references CLUSTERS (CLUSTER_ID)
  deferrable initially immediate;

create index IDX_CLSTR_MNGD_RLS_CLSTR on CLUSTER_MANAGED_RELEASES (CLUSTER_ID);

alter table CLUSTER_MANAGED_RELEASES
  add constraint FK_CLSTR_MNGD_RLS_RLS
  foreign key (RELEASE_ID)
  references RELEASES (RELEASE_ID)
  deferrable initially immediate;

create index IDX_CLSTR_MNGD_RLS_RLS on CLUSTER_MANAGED_RELEASES (RELEASE_ID);

create table CLUSTER_ACTIVATED_RELEASES (
  CLUSTER_ID number constraint NOT_NULL_CLSTR_ACTV_RLS_CLSTR not null,
  RELEASE_ID number constraint NOT_NULL_CLSTR_ACTV_RLS_RLS not null,
  primary key (CLUSTER_ID, RELEASE_ID)
);

alter table CLUSTER_ACTIVATED_RELEASES
  add constraint FK_CLSTR_ACTV_RLS_CLSTR
  foreign key (CLUSTER_ID)
  references CLUSTERS (CLUSTER_ID)
  deferrable initially immediate;

create index IDX_CLSTR_ACTV_RLS_CLSTR on CLUSTER_ACTIVATED_RELEASES (CLUSTER_ID);

alter table CLUSTER_ACTIVATED_RELEASES
  add constraint FK_CLSTR_ACTV_RLS_RLS
  foreign key (RELEASE_ID)
  references RELEASES (RELEASE_ID)
  deferrable initially immediate;

create index IDX_CLSTR_ACTV_RLS_RLS on CLUSTER_ACTIVATED_RELEASES (RELEASE_ID);
